import { Inject, Injectable } from '@nestjs/common';
import { MessageBrokerPublisher } from '@mobicoop/message-broker-module';
import { MESSAGE_BROKER_PUBLISHER } from '@src/app.constants';
import { MessagePublisherPort } from '@mobicoop/ddd-library';

@Injectable()
export class MessagePublisher implements MessagePublisherPort {
  constructor(
    @Inject(MESSAGE_BROKER_PUBLISHER)
    private readonly messageBrokerPublisher: MessageBrokerPublisher,
  ) {}

  publish = (routingKey: string, message: string): void => {
    this.messageBrokerPublisher.publish(routingKey, message);
  };
}
